#include "CReader.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>



bool CReader::open(const string &fname,int noBuffered){

	filename = fname;
	int flags=0;

	if (noBuffered==1) {
		flags=O_DIRECT;
	}

	fd = ::open(filename.c_str(), flags | O_RDONLY |  O_LARGEFILE, S_IREAD );
	return fd>0;
}

int CReader::act(){

	startTS();

	#ifdef __linux__
	int ret = pread64(fd,buffer,bufferSize,curpos);
	#else
	int ret = pread(fd,buffer,bufferSize,curpos);
	#endif
	endTS();
	curpos += bufferSize;
	return ret;

}



