
#include "CWriter.h"

int CWriter::act(){

	startTS();
	int ret = write(fd,buffer,bufferSize);
	endTS();
	return ret;
}


bool CWriter::open(const string &fname,int noBuffered){

	filename = fname;
	int flags=0;
	if (noBuffered==1) {
		flags=O_DIRECT;
	}

	fd = ::open(filename.c_str(), flags | O_WRONLY | O_LARGEFILE | O_CREAT , 0 );
	if (fd>0){
		if ( lseek(fd,curpos,SEEK_SET) < 0 ) {
			perror("failed to lseek");
			return false;
		}
	}
	return true;
}


