
#ifndef  _IOINITIATOR_H_
#define  _IOINITIATOR_H_


#include "CReader.h"
#include "CWriter.h"
#include "AsyncReader.h"

class CIoInitiatorFactory{

	private:
		IoType type;

	public:

	CIoInitiatorFactory(){type=READ;}

	void set_io_type(IoType t){
		type=t;
	}

	CIoInitiator* Create(int bufferSizeBytes,unsigned long long offset=0){

		if(type==READ)
			return   new CReader(bufferSizeBytes,offset);
		else if (type==WRITE)
			return  new CWriter(bufferSizeBytes,offset);
			else
				if (type==ASYNC_READ) {
					return new CasyncReader(bufferSizeBytes,offset);	
				}
	}
};

#endif




