
#include <iostream>
using namespace std;


#include <xfs/libxfs.h>
#include <ctype.h>
#include <sys/unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>

int main(int argc,char* argv[])
{
	if (argc<2) {
		cout << "usage: xfs_unsetrt <filename>" << endl;
		return -1;
	}
	string dest = string(argv[1]);

	struct fsxattr myfsxattr={0};

	int fd = open(dest.c_str(),O_RDWR);
	if ( fd<0){
		perror("open:");
		return -1;
	}

	if ( ioctl(fd,XFS_IOC_FSGETXATTR,&myfsxattr) < 0 ){
		perror("XFS_IOC_FSSETXATTR:");
		return -1;
        }
         

	myfsxattr.fsx_xflags =0;

	if ( ioctl(fd,XFS_IOC_FSSETXATTR,&myfsxattr) < 0 ){
		perror("XFS_IOC_FSSETXATTR:");
		return -1;
	}
	
	close(fd);

	return 0;
}


