#include "AsyncReader.h"
#include "AsyncSpooler.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>



CasyncIoSpooler* mainIO;

bool CasyncReader::open(const string &fname,int noBuffered){

	filename = fname;
	int flags=0;

	if (noBuffered==1) {
		flags=O_DIRECT;
	}

	fd = ::open(filename.c_str(), flags | O_RDONLY |  O_LARGEFILE, S_IREAD );
	io_prep_pread(&cb,fd,buffer,bufferSize,curpos);
	return fd>0;
}


//
//	we take time and submit the io 
//
int CasyncReader::act(){

	int ret = cb.u.c.nbytes;
	// prepare context buffer
	io_prep_pread(&cb,fd,buffer,bufferSize,curpos);
	curpos += cb.u.c.nbytes;
	endTS();  
	mainIO->SubmitIO(this);
	return (ret);
}


