
#include <iostream>
using namespace std;


#include <xfs/libxfs.h>
#include <ctype.h>
#include <sys/unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>

int main(int argc,char* argv[])
{
	if (argc<2) {
		cout << "usage: xfs_setrt <filename>  [rt]" << endl;
		return -1;
	}
	int rt=0;
	string dest = string(argv[1]);
	if (argc==3) {
		rt =1;
	}

	struct fsxattr myfsxattr;
	struct xfs_flock64 file;

	int fd = open(dest.c_str(),O_CREAT|O_RDWR);
	if (rt) {

		myfsxattr.fsx_xflags =  XFS_XFLAG_REALTIME;
		if ( ioctl(fd,XFS_IOC_FSSETXATTR,&myfsxattr) < 0 ){
		perror("XFS_IOC_FSSETXATTR:");
		return -1;
		}
	}

	file.l_whence = 0;
	file.l_start = 0;
	file.l_len=1*1024*1024;

	if ( ioctl(fd,XFS_IOC_RESVSP,&file) < 0 ){
		perror("XFS_IOC_RESVSP");
		return -1;
	}
	char buffer[1048576]={'a'};
	for (int i = 0 ; i < file.l_len ; i += sizeof(buffer)) {
		write(fd,buffer,sizeof(buffer));
	}
	close(fd);

	return 0;
}


